#include "idescrpt.h"
#pragma hdrstop

#include "f_script.h"
#include "idescrpt_nav.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TScriptForm *ScriptForm;
//---------------------------------------------------------------------------
__fastcall TScriptForm::TScriptForm(TComponent* Owner)
        : TForm(Owner)
{ Redraw("");
  if (IsWarningNeeded("HelpPageWarning")) PageControl->ActivePage=About;
  else PageControl->ActivePage=Interactive;
}
__fastcall TScriptForm::~TScriptForm()
{
}

bool __fastcall TScriptForm::IsWarningNeeded(AnsiString s)
{ bool needed=false;
  LONG res; HKEY skey; DWORD valtype,valsize,val,disp;
  res=RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\Lu\\IDE Script",0,KEY_ALL_ACCESS,&skey);
  if (res!=ERROR_SUCCESS) needed=true;
  else
  { valsize=sizeof(val); res=RegQueryValueEx(skey,s.c_str(),0,&valtype,(LPBYTE)&val,&valsize);
    if (res!=ERROR_SUCCESS) needed=true;
    else
    { if (val==0) needed=true; else needed=false;
    }
    RegCloseKey(skey);
  }
  if (!needed) return false;
  res=RegCreateKeyEx(HKEY_CURRENT_USER,"Software\\Lu\\IDE Script",
                     0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&skey,&disp);
  if (res!=ERROR_SUCCESS) return needed;
  val=1;
  RegSetValueEx(skey,s.c_str(),0,REG_DWORD,(LPBYTE)&val,sizeof(val));
  RegCloseKey(skey);
  return needed;
}
//---------------------------------------------------------------------------
void __fastcall TScriptForm::bRedrawClick(TObject *Sender)
{ Redraw(Path->Text);
}
//---------------------------------------------------------------------------
void __fastcall TScriptForm::Redraw(AnsiString s)
{ if (s=="") s="Application";
  TComponent *com=NULL;
  bool error=false;
  AnsiString final="";
  while (s!="" && !error)
  { AnsiString first=s;
    int i=first.Pos("->");
    if (i==0) s="";
    else
    { first=s.SubString(1,i-1);
      s=s.SubString(i+2,s.Length()-i-1);
    }
    if (first=="Application") {final="Application";com=Application;}
    else
    { if (com==NULL) {error=true;}
      else
      { TComponent *cd=IDEChildComponentFromString(com,first);
        if (cd==NULL) {error=true;}
        else
        { final=final+"->"+first;com=cd;
        }
      }
    }
  }
  if (error && com==NULL) {com=Application; final="Application";}
  Path->Text=final;
  //
  Hierarchy->Clear();
  if (com->Owner!=NULL) Hierarchy->Items->Add("..");
  for (int i=0;i<com->ComponentCount;i++)
  { TComponent*cd=com->Components[i];
    Hierarchy->Items->Add(StringFromIDEChildComponent(com,cd));
  }
  Hierarchy->ItemIndex=-1;
  //
  AnsiString title=com->Name;
  if (title!="") title=title+" "; title=title+"["+com->ClassName()+"]";
  Caption=title;
  //
  Property->Clear();
  PPropInfo props[1000];
  for (int i=0; i<1000; i++) props[i]=NULL;
  GetPropInfos((TTypeInfo*)com->ClassInfo(),(TPropList*)props);
  int i=0;
  while (props[i]!=NULL)
  { AnsiString s=GetStrProp(com,props[i]);
    Property->Items->Add(AnsiString(props[i]->Name)+" = "+s);
    i++;
  }

}


//---------------------------------------------------------------------------

void __fastcall TScriptForm::HierarchyClick(TObject *Sender)
{ int i=Hierarchy->ItemIndex;
  if (i==-1) return;
  AnsiString s=Hierarchy->Items->Strings[i];
  if (s=="..") {Up();return;}
  s=Path->Text+"->"+s;
  Redraw(s);
}

//---------------------------------------------------------------------------
void __fastcall TScriptForm::Up()
{ AnsiString s=Path->Text;
  char *c=s.c_str();
  int lastpos=1;
  int i=0;
  while (c[i]!=0 && c[i+1]!=0)
  { if (c[i]=='-' && c[i+1]=='>') lastpos=i;
    i++;
  }
  Redraw(s.SubString(1,lastpos));
}

void __fastcall TScriptForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{ Action=caFree;
}

void __fastcall TScriptForm::HierarchyKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ if (Key==VK_BACK) Up();
}
//---------------------------------------------------------------------------
void __fastcall TScriptForm::Failed()
{ Application->MessageBox("Failed","Failed",MB_OK);
}

void __fastcall TScriptForm::ReadyAsynchrony()
{ Hide();
  ContinueIDEAsynchronouslyWith(AfterAsynchrony);
}
void __fastcall TScriptForm::AfterAsynchrony(TObject*Sender)
{ Show();
}

void __fastcall TScriptForm::ClickMenuItemClick(TObject *Sender)
{ TMenuItem *mi=dynamic_cast<TMenuItem*>(IDEComponentFromPath(Path->Text));
  if (mi==NULL) {Failed();return;}
  AnsiString s=AnsiString("ClickMenuItem(\"")+Path->Text+"\");";
  if (Asynchronous->Checked) s=s+" *async*";
  ScriptMemo->Lines->Add(s);
  if (Asynchronous->Checked) ReadyAsynchrony();
  ClickIDEMenuItem(Path->Text);
}
//---------------------------------------------------------------------------

void __fastcall TScriptForm::ClickButtonClick(TObject *Sender)
{ TButton *btn=dynamic_cast<TButton*>(IDEComponentFromPath(Path->Text));
  if (btn==NULL) {Failed();return;}
  AnsiString s=AnsiString("ClickButton(\"")+Path->Text+"\");";
  if (Asynchronous->Checked) s=s+" *async*";
  ScriptMemo->Lines->Add(s);
  if (Asynchronous->Checked) ReadyAsynchrony();
  ClickIDEButton(Path->Text);
}
//---------------------------------------------------------------------------



void __fastcall TScriptForm::GetEditTextClick(TObject *Sender)
{ TEdit *ed=dynamic_cast<TEdit*>(IDEComponentFromPath(Path->Text));
  if (ed==NULL) {Failed();return;}
  AnsiString s=AnsiString("val=GetEditText(\"")+Path->Text+"\");";
  ScriptMemo->Lines->Add(s);
  Value->Text=GetIDEEditText(Path->Text);
}
//---------------------------------------------------------------------------

void __fastcall TScriptForm::GetCheckboxClick(TObject *Sender)
{ TCheckBox *cb=dynamic_cast<TCheckBox*>(IDEComponentFromPath(Path->Text));
  if (cb==NULL) {Failed();return;}
  AnsiString s=AnsiString("b=GetCheckBox(\"")+Path->Text+"\");";
  ScriptMemo->Lines->Add(s);
  bool b=GetIDECheckBox(Path->Text);
  Value->Text=b?"true":"false";
}
//---------------------------------------------------------------------------

void __fastcall TScriptForm::SetEditTextClick(TObject *Sender)
{ TEdit *ed=dynamic_cast<TEdit*>(IDEComponentFromPath(Path->Text));
  if (ed==NULL) {Failed();return;}
  AnsiString val=Value->Text;
  AnsiString s=AnsiString("SetEditText(\"")+Path->Text+"\",\""+val+"\");";
  ScriptMemo->Lines->Add(s);
  SetIDEEditText(Path->Text,val);
}
//---------------------------------------------------------------------------

void __fastcall TScriptForm::SetCheckboxClick(TObject *Sender)
{ TCheckBox *cb=dynamic_cast<TCheckBox*>(IDEComponentFromPath(Path->Text));
  if (cb==NULL) {Failed();return;}
  AnsiString val=Value->Text.LowerCase(); bool b=false;
  if (val=="true" || val=="t" || val=="1" || val=="checked" || val=="x") b=true;
  if (b==true) val="true"; else val="false";
  AnsiString s=AnsiString("SetCheckBox(\"")+Path->Text+"\","+val+");";
  ScriptMemo->Lines->Add(s);
  SetIDECheckBox(Path->Text,b);
}
//---------------------------------------------------------------------------

void __fastcall TScriptForm::SetActivePageClick(TObject *Sender)
{ TPageControl *pc=dynamic_cast<TPageControl*>(IDEComponentFromPath(Path->Text));
  TTabSheet *ts=dynamic_cast<TTabSheet*>(IDEComponentFromPath(Value->Text));
  if (pc==NULL || ts==NULL) {Failed();return;}
  AnsiString s=AnsiString("SetActivePage(\"")+Path->Text+"\",\""+Value->Text+"\");";
  ScriptMemo->Lines->Add(s);
  SetIDEActivePage(Path->Text,Value->Text);
}
//---------------------------------------------------------------------------

void __fastcall TScriptForm::ScriptMemoKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ if (!Shift.Contains(ssCtrl)) return;
  if (Key=='C') ScriptMemo->CopyToClipboard();
  if (Key=='X') ScriptMemo->CutToClipboard();
  if (Key=='V') ScriptMemo->PasteFromClipboard();
  if (Key=='Z') ScriptMemo->Clear();
}
//---------------------------------------------------------------------------

